/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-headers-form.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {html, css, LitElement} from 'lit-element';

import {ValidatableMixin} from '@anypoint-web-components/validatable-mixin/validatable-mixin.js';

import {ApiFormMixin} from '@api-components/api-form-mixin/api-form-mixin.js';

/**
 * HTTP headers form build from AMF json/ld model.
 */
declare class ApiHeadersForm extends
  ApiFormMixin(
  ValidatableMixin(
  Object)) {

  /**
   * Current value of the headers. Changing the value will update the list
   * of the headers.
   */
  value: string|null|undefined;
  model: any;

  /**
   * When set the editor is in read only mode.
   */
  readOnly: boolean|null|undefined;
  onvalue: Function|null;
  onmodel: Function|null;

  /**
   * Prohibits rendering of the documentation (the icon and the
   * description).
   * Note, Set is separately for `api-view-model-transformer`
   * component as this only affects "custom" items.
   */
  noDocs: boolean|null|undefined;

  /**
   * Automatically validates the input on value change.
   */
  autoValidate: boolean|null|undefined;

  /**
   * Enables Anypoint legacy styling
   */
  legacy: boolean|null|undefined;

  /**
   * Enables Material Design outlined style
   */
  outlined: boolean|null|undefined;
  render(): any;

  /**
   * Registers an event handler for given type
   *
   * @param eventType Event type (name)
   * @param value The handler to register
   */
  _registerCallback(eventType: String|null, value: Function|null): void;

  /**
   * Appends an empty header to the list.
   */
  add(): void;

  /**
   * Focuses on last form item.
   */
  focusLast(): void;
  _modelChanged(model: any, readOnly: any): void;

  /**
   * Updates value of the element when model change.
   *
   * @param validate When true then it performs validation after setting
   * the value.
   */
  _updateValue(validate: Boolean|null): void;

  /**
   * Adds documentation for headers that doesn't have it already.
   *
   * @param model View model
   */
  _autoDescribeModel(model: any[]|null): void;

  /**
   * Queries for header information and updates header info if needed.
   *
   * @param item View model item
   * @param index Position of the item in `model` array
   */
  _fillModelDescription(item: object|null, index: Number|null): void;

  /**
   * Queries for a header definition.
   *
   * @param name header name to query
   * @returns Header definition or undefined.
   */
  _queryHeaderData(name: String|null): object|null|undefined;
  _getValidity(): any;
  _enableCheckedHandler(e: any): void;
  _nameChangeHandler(e: any): void;
  _valueChangeHandler(e: any): void;
  _optionalHanlder(e: any): void;
}

declare global {

  interface HTMLElementTagNameMap {
    "api-headers-form": ApiHeadersForm;
  }
}
